http://acm.hdu.edu.cn/showproblem.php?pid=3038 并查集权值应用

题意:[1-n]的区间,有m个询问,每个询问表示[e,f]的和是g,问一共有多少组矛盾

sum[i]表示i到根节点的和,求区间和用sum[f]-sum[e-1];

为了简化e--;

因为是并查集  要出来最前面的那个数

1.如果共同祖先相同   直接用sum[f]-sum[e]与给的值g相比较

2.,不是共同祖先包括两种

这种为y>x   fa[y]=x; 所以 对应sum[y]=sum[e]+g-sum[f];

还有x>y   让fa[x]=y  所以对应  sum[x]=sum[f]-g-sum[e];

下面 代码

#include<cstdio>
#include<cstring>
#include<algorithm>
#include<iostream>
#include<queue>
#include<map>
#include<vector>
#include<math.h>
using namespace std;
#define ll long long
#define INF 0x3f3f3f3f
#define maxn 10005
#define N 200005
int fa[N],sum[N];
int Find(int x)
{
    if(x!=fa[x])
    {
        int po=fa[x];
        fa[x]=Find(fa[x]);
        sum[x]+=sum[po];
    }
    return fa[x];
}
int main()
{
    int n,m,e,f,g;
    while(scanf("%d%d",&n,&m)!=EOF)
    {
        for(int i=0; i<=n; i++)
        {
            fa[i]=i;
            sum[i]=0;
        }
        int ans=0;
        while(m--)
        {
            scanf("%d%d%d",&e,&f,&g);
            e--;
            int x=Find(e);//查找这个点的父节点
            int y=Find(f);if(x==y)
            {
                if(sum[f]-sum[e]!=g)
                    ans++;
            }
            else if(x<y)
            {
                fa[y]=x;
                sum[y]=g+sum[e]-sum[f];
            }
            else
            {
                fa[x]=y;
                sum[x]=sum[f]-g-sum[e];
            }
        }
        printf("%d\n",ans);
    }
    return 0;
}
时间: 2024-11-08 20:53:47

http://acm.hdu.edu.cn/showproblem.php?pid=3038 并查集权值应用的相关文章

HDU 4911 http://acm.hdu.edu.cn/showproblem.php?pid=4911(线段树求逆序对)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=4911 解题报告: 给出一个长度为n的序列,然后给出一个k,要你求最多做k次相邻的数字交换后,逆序数最少是多少? 因为每次相邻的交换操作最多只能减少一个逆序对,所以最多可以减少k个逆序对,所以我们只要求出原来的序列有多少个逆序对然后减去k再跟0取较大的就可以了. 因为数据范围是10的五次方,所以暴力求肯定会TLE,所以要用n*logn算法求逆序对,n*logn算法有几种可以求逆序对的: 线段树,树状数

HDU-4632 http://acm.hdu.edu.cn/showproblem.php?pid=4632

http://acm.hdu.edu.cn/showproblem.php?pid=4632 题意: 一个字符串,有多少个subsequence是回文串. 别人的题解: 用dp[i][j]表示这一段里有多少个回文串,那首先dp[i][j]=dp[i+1][j]+dp[i][j-1],但是dp[i+1][j]和dp[i][j-1]可能有公共部分,所以要减去dp[i+1][j-1]. 如果str[i]==str[j]的话,还要加上dp[i+1][j-1]+1. 但是自己却是这样想的,把每个区间都要看

http://acm.hdu.edu.cn/showproblem.php?pid=2825

地址:http://acm.hdu.edu.cn/showproblem.php?pid=2825 题目: Wireless Password Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 6862    Accepted Submission(s): 2279 Problem Description Liyuan lives in a

字符串处理 最佳裁判http://acm.hdu.edu.cn/showproblem.php?pid=4520

#include <stdio.h> int main() { int N; scanf("%d",&N);//先输入 double a[N],b[N],c,d=0,o[N-1],e,f;//这里定义3个数组下面会用到 for (int i=0; i<N; i++) { scanf("%lf",&a[i]); b[i]=a[i];//得到2个一样的数组,因为有一个数组因为排序要改变 } for (int i=0; i<N-1;

Help him http://acm.hdu.edu.cn/showproblem.php?pid=5059

题目是昨天晚上的BC.昨天晚上一直卡在第二题,囧. 今天看到题解之后,觉得自己想的也是差不多的,该考虑的也考虑到的.究竟是为什么会错.然后我就改了交,改了交.终于让我改对了一次,我找到了自己的代码中哪段有问题. 接下来上代码: wa code: int but=0; if(!sig) but=1; else but=0; long long c=0,r=1; for(int i=strlen(str)-1; i>=but; i--) { //not digit if(str[i]<'0'||s

饭卡 (背包01) http://acm.hdu.edu.cn/showproblem.php?pid=2546

/* 从一组数据中选出n个数,使这n个数的和最接近一个值x, 背包问题, 从一系列菜中,从最贵的菜(MAX)之外中选出几个菜,使菜的总价格sum最接近money-5:money-sum-MAX; 钱数相当于背包总容量,菜相当于价值和体积一样物品: */ #include <iostream> #include <cstdio> #include <cstring> #include <algorithm> using namespace std; int d

HDU 1455 http://acm.hdu.edu.cn/showproblem.php?pid=1455

#include<stdio.h> #include<stdlib.h> #include<math.h> #include<string.h> #define N 70 int f, vis[N], v, n, a[N]; int cmp(const void *a, const void *b) { return *(int *)b - *(int *)a; } void DFS(int w, int sum) { int i; if(sum == 0)

HDU5122 http://acm.hdu.edu.cn/showproblem.php?pid=5122

1 #include <stdio.h> 2 #include <string.h> 3 int s[1011010]; 4 int main() 5 { 6 int T,sum,n,f; 7 scanf("%d",&T); 8 f=0; 9 while(T--) 10 { 11 f++; 12 scanf("%d",&n); 13 for(int i=0;i<n;i++) 14 { 15 scanf("%d&

http://acm.hdu.edu.cn/showproblem.php?pid=2579

#include<stdio.h> #include<string.h> #include<queue> #define N 110 int m, n, k, x1, x2, y1, y2; char map[N][N]; int v[N][N][N];//当时间是k的倍数时,障碍消失,之后又重现,所以在平时使用的二维标记数组中再加一维 int d[4][2] = {{-1, 0}, {1, 0}, {0, -1}, {0, 1}}; using namespace s